unit stringdrawer2;

interface

uses Classes, SysUtils, 
  openglunit,
  SDL, GLU, GL, mediamanagerunit,
  types3d;

const CHAR_WIDTH = 8;
const CHAR_HEIGHT = 8;

procedure drawString(x,y:integer; s:string; r, g, b:single);
procedure drawStringV(x,y:integer; s:string; r, g, b:single);
procedure beginDrawString;
procedure endDrawString;
implementation

procedure beginDrawString;
begin
	  glDisable(GL_DEPTH_TEST);
  glEnable(GL_BLEND);
  glEnable(GL_TEXTURE_2d);
  glMatrixMode(GL_PROJECTION);
  glPushMatrix;
  glLoadIdentity();
  glOrtho(0, SCREEN_WIDTH, SCREEN_HEIGHT, 0, -100, 100);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

end;

procedure endDrawString;
begin
  glDisable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE);
  glEnable(GL_DEPTH_TEST);
  glMatrixMode(GL_PROJECTION);
  glPopMatrix;
  glMatrixMode(GL_MODELVIEW);

end;

procedure drawChar(x,y:integer; c:char);
var tx,ty,w,h:single;
    i:byte;
begin
  i:=ord(C)-32;
  tx:=((i mod 16)*CHAR_WIDTH)/128;
  ty:=((i div 16)*CHAR_HEIGHT)/128 + 0.5;
  w := CHAR_WIDTH/128;
  h := CHAR_HEIGHT/128;

  glBegin( GL_TRIANGLE_STRIP  );         // Drawing Using Triangles
    glTexCoord2f(tx,ty);
    glVertex2f(  x,  y );
    glTexCoord2f(tx,ty+h);
    glVertex2f(  x,  y+CHAR_HEIGHT );
    glTexCoord2f(tx+w,ty);
    glVertex2f(  x+CHAR_WIDTH,  y );
    glTexCoord2f(tx+w,ty+h);
    glVertex2f(  x+CHAR_WIDTH,  y+CHAR_HEIGHT );
  glEnd;                            // Finished Drawing The Triangles

end;

procedure drawString(x,y:integer; s:string; r, g, b:single);
var i:integer;
begin
  glColor3f(r,g,b);

  for i:=1 to length(s) do
   drawChar(x+(i-1)*(CHAR_WIDTH-1), y, s[i]);
end;

procedure drawStringV(x,y:integer; s:string; r, g, b:single);
var i:integer;
begin
  glColor3f(r,g,b);

  for i:=1 to length(s) do
   drawChar(x,y+(i-1)*(CHAR_WIDTH-1), s[i]);
end;


end.