{** This unit exports functions to save and load
data structure to and from XML }

unit xml3d;

(*

This unit was written by Nicola {MSX} Lugato.

http://msx.rules.it
nicola@lugato.net
nicola.lugato@gmail.com

It is released under the term of
The GNU General Public License as published by the Free
Software Foundation.

*)



interface

uses types3d, Nicola_xmlparser, SysUtils;

function XMLToVector(node:TXMLNode):TVector;
function XMLToVertex(node:TXMLNode):TVertex;
function XMLToFACE(node:TXMLNode):TFace;
function VectorToXML(v:TVector):TXMLNode;
//function RGBtoXML(v:TRGB):TXMLNode;
//function XMLToRGB(node:TXMLNode):TRGB;

implementation

function VectorToXML(v:TVector):TXMLNode;
begin
result:=TXMLNode.Create('VECTOR');
result.AppendChildText('X',FloatToStr(v.x));
result.AppendChildText('Y',FloatToStr(v.y));
result.AppendChildText('Z',FloatToStr(v.z));
end;

(*
function XMLToRGB(node:TXMLNode):TRGB;
begin
result[0]:=node.query('R').number;
result[1]:=node.query('G').number;
result[2]:=node.query('B').number;
end;

function RGBtoXML(v:TRGB):TXMLNode;
begin
result:=TXMLNode.Create('RGB');
result.AppendChildNumber('R',v[0]);
result.AppendChildNumber('G',v[1]);
result.AppendChildNumber('B',v[2]);
end;
*)

function XMLToVector(node:TXMLNode):TVector;
begin
result.x:=StrToFloat(node.query('X').Text);
result.y:=StrToFloat(node.query('Y').Text);
result.z:=StrToFloat(node.query('Z').Text);
end;



function XMLToVertex(node:TXMLNode):TVertex;
begin
result.x:=StrToFloat(node.query('X').Text);
result.y:=StrToFloat(node.query('Y').Text);
result.z:=StrToFloat(node.query('Z').Text);
if node.query('NX') <> nil then
 begin
  result.nx:=StrToFloat(node.query('NX').Text);
  result.ny:=StrToFloat(node.query('NY').Text);
  result.nz:=StrToFloat(node.query('NZ').Text);
 end;
if node.query('U') <> nil then
 begin
  result.tu:=StrToFloat(node.query('U').Text);
  result.TV:=StrToFloat(node.query('V').Text);
 end;
end;

function XMLToFACE(node:TXMLNode):TFace;
begin
result.point[1]:=node.query('A').Number;
result.point[2]:=node.query('B').Number;
result.point[3]:=node.query('C').Number;
if node.query('AU') <> nil then
 begin
   result.uv[1].u:=StrToFloat(node.query('AU').Text);
   result.uv[1].v:=StrToFloat(node.query('AV').Text);
   result.uv[2].u:=StrToFloat(node.query('BU').Text);
   result.uv[2].v:=StrToFloat(node.query('BV').Text);
   result.uv[3].u:=StrToFloat(node.query('CU').Text);
   result.uv[3].v:=StrToFloat(node.query('CV').Text);
 end;

end;

initialization

DecimalSeparator:='.'; // for reading float values out of xml

end.
 
